Attribute VB_Name = "Module1"
'----------------------
'  D3D IM : Example 9
'----------------------
' Sylvain Dupont
' Le coin des dveloppeurs de jeux - http://francis.dupont.free.fr/coindev/
' The corner of the developer of games - http://francis.dupont.free.fr/coindev/english/

'*---------------------------
' 3D Terrain + Image BackGround Example
'  Exemple de terrain + fond de paysage
'*----------------------------

'Declaration (place them in the same module in the Declaration section)

Public DirectX As New DirectX7  'Create a new DirectX class
Public D3D As Direct3D7        'The Direct3D Immediate Mode object
Public EnumDevice As Direct3DEnumDevices
Public DeviceGUID As String

Public DD As DirectDraw7       'The DirectDraw7 object
Public Primary As DirectDrawSurface7   'The primary surface (screen)
Public BackBuffer As DirectDrawSurface7 'The BackBuffer surface (memory)

Public Device As Direct3DDevice7
Public Viewport As D3DVIEWPORT7   'The viewport is now a user type

Public Projection3D As D3DMATRIX
Public ViewMatrix As D3DMATRIX        'Camera

Public GrassTexture As DirectDrawSurface7   'Background and textures
Public BackGround As DirectDrawSurface7     'fond et textures
Public Title As DirectDrawSurface7

Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As Any) As Long ' lpPoint As POINTAPI

Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Public PosX As Single, PosY As Single, Ang As Single, FPS As Single, OldFPS As Long, NbIMage As Integer
Public LeftKey, RightKey, UpKey, Downkey, BackFlag, Espace, AddKey, SubKey, Precision

Public T As Terrain

Public Type Terrain
  O() As D3DLVERTEX
  Index() As Integer
End Type

Dim Map() As Long

Sub ComputeFPS()
   NbIMage = NbIMage + 1
   If DirectX.TickCount - 1000 > OldFPS Then
     calc = DirectX.TickCount - OldFPS
     OldFPS = DirectX.TickCount
     FPS = Int(NbIMage / (calc / 1000))
     NbIMage = 0
   End If
   
   
End Sub


Function LoadTerrain(HeightMapFile As String, XPrecision, ZPrecision, YFactor, tu As Single, tv As Single) As Terrain
  '----------------
  ' Load the terrain from a height surface
  ' Charge le terrain  partir d'une surface de hauteur.
  '------------------
  Form1.Pict.Visible = True
  
  ' Load the height surface in a PictureBox / Charge l'image "relief" dans un PictureBox
  Form1.Pict.Picture = LoadPicture(HeightMapFile)
  
  ' Compute rows and columns / Calcule le nombre de ranges et de colonnes
  mapx = Int(Form1.Pict.ScaleWidth / XPrecision)
  mapy = Int(Form1.Pict.ScaleHeight / ZPrecision)

  'Dim Arrays / Redimensionne les tableaux
  ReDim Map(mapx, mapy)
  ReDim LoadTerrain.O(mapx * mapy + 1)
   
   h = 0
   'For each point in the surface  / Pour chaque point dans la surface
   For X = 1 To mapx
    For Y = 1 To mapy
     'Find the color of the point / Trouve la couleur du point
     Map(X, Y) = Form1.Pict.Point((X - 1) * XPrecision, (Y - 1) * ZPrecision) Mod 256
     'Change Index / Incrmente l'index
      h = h + 1
      
      'Compose the D3DLVERTEX / Compose le vertex
     LoadTerrain.O(h) = LVertex(Vector(X * XPrecision, YFactor * Map(X, Y), Y * ZPrecision), DirectX.CreateColorRGBA(1, 1, 1, 1), X / mapx * tu, Y / mapy * tv)
    Next Y
   Next X
   j = 0
   
   ' Now Indexes for DrawIndexedPrimitive / Maintenant les index pour la mthode DrawIndexedPrimitive
   ' 2 Triangles per face / 2 triangles par face
   ReDim LoadTerrain.Index(mapx * mapy * 6)
   For X = 1 To mapx - 1
    For Y = 1 To mapy - 1
     LoadTerrain.Index(j + 2) = (X - 1) * mapy + Y
     LoadTerrain.Index(j + 1) = X * mapy + Y
     LoadTerrain.Index(j + 0) = (X - 1) * mapy + Y + 1
     LoadTerrain.Index(j + 5) = X * mapy + Y
     LoadTerrain.Index(j + 4) = X * mapy + Y + 1
     LoadTerrain.Index(j + 3) = (X - 1) * mapy + Y + 1
     j = j + 6
    Next Y
   Next X
   ReDim Preserve LoadTerrain.Index(j)
  
  'Disable the PictureBox / Dsactive la PictureBox
  Form1.Pict.Visible = False
  
  
End Function


Function TLVertex(X, Y, Z, rhw, color As D3DCOLORVALUE, specular As D3DCOLORVALUE, tu, tv) As D3DTLVERTEX
 TLVertex.sx = X
 TLVertex.sy = Y
 TLVertex.sz = Z
 TLVertex.color = DirectX.CreateColorRGBA(color.R, color.G, color.b, color.a)
 TLVertex.specular = DirectX.CreateColorRGBA(specular.R, specular.G, specular.b, specular.a)
 TLVertex.rhw = rhw
 TLVertex.tu = tu
 TLVertex.tv = tv
End Function


' CreateMenu Function : create a set of 4 TLVertex to display the title
' Fonction CreateMenu : Cr un ensemble de 4 TLVertex pour afficher le titre
Function CreateMenu(X, Y, x1, y1, c, ByRef vx() As D3DTLVERTEX) As Integer
 rx = X * Viewport.lWidth
 ry = Y * Viewport.lHeight
 rx1 = x1 * Viewport.lWidth
 ry1 = y1 * Viewport.lHeight
 vx(1 + c) = TLVertex(rx, ry, 0, 0.5, DXColor(1, 1, 1, 1), DXColor(1, 1, 1, 1), 0, 0)
 vx(2 + c) = TLVertex(rx1, ry, 0, 0.5, DXColor(1, 1, 1, 1), DXColor(1, 1, 1, 1), 1, 0)
 vx(4 + c) = TLVertex(rx1, ry1, 0, 0.5, DXColor(1, 1, 1, 1), DXColor(1, 1, 1, 1), 1, 1)
 vx(3 + c) = TLVertex(rx, ry1, 0, 0.5, DXColor(1, 1, 1, 1), DXColor(1, 1, 1, 1), 0, 1)
 
 
End Function


Function DXColor(R, G, b, a) As D3DCOLORVALUE
 DXColor.a = a
 DXColor.b = b
 DXColor.G = G
 DXColor.R = R
End Function



Function REC(X, Y, xa, ya) As RECT
 REC.Bottom = ya
 REC.Left = X
 REC.Right = xa
 REC.Top = Y
End Function
Function LVertex(V As D3DVECTOR, color As Long, tu, tv) As D3DLVERTEX
 LVertex.X = V.X
 LVertex.Y = V.Y
 LVertex.Z = V.Z
 LVertex.color = color
 LVertex.specular = color
 LVertex.tu = tu
 LVertex.tv = tv
End Function

Public Function CreateSurfaceFromFile(ByVal FileName As String, SurfaceDesc As DDSURFACEDESC2) As DirectDrawSurface7
On Error GoTo errs
    Dim Picture As StdPicture
    Dim width As Long
    Dim height As Long
    Dim Surface As DirectDrawSurface7
    Dim hdcPicture As Long  ' Picture device context
    Dim hdcSurface As Long  ' Surface device context
    ' Load picture
    Set Picture = LoadPicture(FileName)
    ' Convert from vbHimetric to vbPixels
    width = CLng((Picture.width * 0.001) * 567 / Screen.TwipsPerPixelX)
    height = CLng((Picture.height * 0.001) * 567 / Screen.TwipsPerPixelY)
    ' Update surface description
    With SurfaceDesc
        If .lFlags = 0 Then .lFlags = DDSD_CAPS
        .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
        If .ddsCaps.lCaps = 0 Then .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        If .lWidth = 0 Then .lWidth = width
        If .lHeight = 0 Then .lHeight = height
    End With
    ' Create surface
    Set Surface = DD.CreateSurface(SurfaceDesc)
    ' Create memory device
    hdcPicture = CreateCompatibleDC(0)
    ' Select the bitmap in this memory device
    SelectObject hdcPicture, Picture.Handle
    ' Get the surface's DC
    hdcSurface = Surface.GetDC
    ' Copy from the memory device to the DirectDrawSurface
    StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, hdcPicture, 0, 0, width, height, SRCCOPY
    ' Release the surface's DC
    Surface.ReleaseDC hdcSurface
    ' Release the memory device and the bitmap
    DeleteDC hdcPicture
    Set Picture = Nothing
    Set CreateSurfaceFromFile = Surface
    Set Surface = Nothing
  Exit Function
errs:
  Unload3D
  End
  
End Function

Public Function CreateTextureSurface(sFile As String, extraFlags As Integer, w As Long, h As Long) As DirectDrawSurface7
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
                        
            
            If ((1 And extraFlags) _
                  Or (2 And extraFlags)) Then
                  If (.lRGBAlphaBitMask = 0) Then bOK = False
                  'DDPF_ALPHAPIXELS
            Else
                  If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
                  
            
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    If (((1 And extraFlags) _
          Or (2 And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT
        
    Else
        ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB
  
    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0

    Else
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddsCaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

 
    End If

    If sFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        Set SurfaceObject = CreateSurfaceFromFile(sFile, ddsd3)
    End If
    
    
 
    
   
     Set CreateTextureSurface = SurfaceObject: Exit Function

    
    
789:
 Debug.Print "Error Create surface "; Err.Description + " "; Err.Number
 Resume Next
End Function

Sub Game()
On Error GoTo TreatError3
Dim DDS As DDSURFACEDESC2
DDS.lFlags = DDSD_WIDTH Or DDSD_HEIGHT
DDS.lHeight = Viewport.lHeight / 2 + 12
DDS.lWidth = Viewport.lWidth * 5 / 2
Debug.Print "ici"

' Call the LoadTerrain function : Transform Height surface to 3D vertexes
' Appelle la fonction ChargeTerrain !! La plus importante ! Transforme la surface 2D en points 3D
'
' LoadTerrain  As Terrain (see Declarations)
'
'  Height Surface Map : JPG, GIF or BMP height surface filename.
'                       Nom du fichier JPG, GIF ou BMP de la surface "relief"
'  PrecisionX         : Precision on X-axis
'                       Prcision sur l'axe des X
'
'  PrecisionZ         : Precision on Z-axis
'                       Prcision sur l'axe des Z
'
'  Y Factor           :  Vertex.Y = ColorPoint(x,y) * YFactor
'
'  Tu, TV             : Texture Coordinates of the entire terrain
'                       Coordonnes de textures du terrain entier

T = LoadTerrain(App.Path + "\height.jpg", 4, 4, 0.3, 8, 8)
Precision = 4
'
'

Set BackGround = CreateSurfaceFromFile(App.Path + "\back.jpg", DDS)
Set GrassTexture = CreateTextureSurface(App.Path + "\rock.bmp", 0, 256, 256)
Set Title = CreateTextureSurface(App.Path + "\title3.jpg", 0, 0, 0)
BackFlag = 1

Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
Device.SetRenderState D3DRENDERSTATE_ZENABLE, D3DZB_TRUE
Device.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, D3DZB_TRUE
Device.SetRenderState D3DRENDERSTATE_ZFUNC, D3DCMP_LESSEQUAL


' Grass vertexes
'Dim SolVertex(4) As D3DLVERTEX
'SolVertex(2) = LVertex(Vector(-500, 0, -500), DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 0)
'SolVertex(1) = LVertex(Vector(500, 0, -500), DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 0)
'SolVertex(4) = LVertex(Vector(-500, 0, 500), DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 32)
'SolVertex(3) = LVertex(Vector(500, 0, 500), DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 32)

' Create title
Dim titleV(4) As D3DTLVERTEX
CreateMenu 0, 0.8, 0.3, 1, 0, titleV()

Device.SetRenderTarget BackBuffer
Device.SetViewport Viewport

Dim RECT As RECT

' Clear Rect
Dim ClearRec(1) As D3DRECT
ClearRec(0).x1 = Viewport.lX
ClearRec(0).y1 = Viewport.lY
ClearRec(0).X2 = Viewport.lWidth
ClearRec(0).Y2 = Viewport.lHeight


BackBuffer.BltColorFill RECT, 0

DirectX.ViewMatrix ViewMatrix, Vector(0, 0, 10), Vector(0, 0, 0), Vector(0, 1, 0), 0
Oldtime = DirectX.TickCount
Do
  systemframe = DirectX.TickCount - Oldtime + 1
  Oldtime = DirectX.TickCount
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  'Calculate the Background X to display / Calcul la position X du fond  afficher
   bakm = (6.28 - Ang) / 6.28 * Viewport.lWidth * 2
  If bakm > Viewport.lWidth * 2 Then bakm = Viewport.lWidth * 2
  If bakm < 0 Then bakm = 0
  Device.Clear 1, ClearRec, D3DCLEAR_ZBUFFER Or D3DCLEAR_TARGET, DirectX.CreateColorRGBA(0, 0, 0, 1), 1, 0
  
  ' Display the part of the background / Affiche la partie du fond
  BackBuffer.Blt REC(0, 0, 0, 0), BackGround, REC(bakm, 0, bakm + Viewport.lWidth / 2, Viewport.lHeight / 2), DDBLT_WAIT
  
  
  DoEvents
  ' Begin to draw / Commence  dessiner
  Device.BeginScene
  
  ' Set the great texture / Met une super texture
  Device.SetTexture 0, GrassTexture
  
  ' Draw the terrain with the T type/ Dessine le terrain avec le type T
  Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_LVERTEX, T.O(0), UBound(T.O()), T.Index(), UBound(T.Index()), D3DDP_WAIT
  
  ' Add Direct3D Terrain title / Ajoute le titre "Direct3D IM Terrain"
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
  Device.SetTexture 0, Title
  Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_TLVERTEX, titleV(1), 4, D3DDP_DEFAULT
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
  
  ' End of the scene / Fin de la scne
  Device.EndScene
  
  Device.SetTransform D3DTRANSFORMSTATE_VIEW, ViewMatrix
  
  'Write some info / Ecris quelques informations
  BackBuffer.SetForeColor RGB(0, 256, 256)
  BackBuffer.DrawText 200, 400, "[Space] : Change texture", False
  BackBuffer.DrawText 200, 420, "Arrow keys / Flches : Move / Bouge", False
  BackBuffer.DrawText 200, 440, "+ / - : Change precision", False
   
  BackBuffer.DrawText 0, 0, "FPS : " + CStr(FPS), False
  
  'Flip to the primary surface (screen) / "Flippe" tout dans la surface primaire
  Primary.Flip Nothing, DDFLIP_WAIT
  
 DoEvents  'don't forget ! / ne pas oublier !
 
 'Change camera matrix / Change la matrice de la camra
 DirectX.ViewMatrix ViewMatrix, Vector(PosX, 50, PosY), Vector(PosX + Cos(Ang), 50, PosY + Sin(Ang)), Vector(0, 1, 0), 0

  'Input management
  'Gestion des touches

  If AddKey = True Then
    AddKey = False
    If Precision > 2 Then Precision = Precision - 1
    T = LoadTerrain(App.Path + "\height.jpg", Precision, Precision, 0.3, 4, 4)
    
  End If
  If SubKey = True Then
    SubKey = False
    If Precision < 32 Then Precision = Precision + 1
    T = LoadTerrain(App.Path + "\height.jpg", Precision, Precision, 0.3, 4, 4)

  End If
  
  If LeftKey = True Then
    Ang = Ang + systemframe * 0.001
  End If
  If RightKey = True Then
    Ang = Ang - systemframe * 0.001
  End If
  If UpKey = True Then
    PosX = PosX + systemframe * Cos(Ang) * 0.09
    PosY = PosY + systemframe * Sin(Ang) * 0.09
  End If
  If Downkey = True Then
    PosX = PosX - systemframe * Cos(Ang) * 0.09
    PosY = PosY - systemframe * Sin(Ang) * 0.09
  End If
  If Espace = True Then
  Espace = False
    BackFlag = 1 - BackFlag
    If BackFlag = 1 Then
     Set BackGround = CreateSurfaceFromFile(App.Path + "\back.jpg", DDS)
    Else
     Set BackGround = CreateSurfaceFromFile(App.Path + "\back3.jpg", DDS)
    End If
  End If
  'Fix angle
  'Vrifie les limites de l'angle
  If Ang > 3.141592 * 2 Then Ang = Ang - 3.141592 * 2
  If Ang < 0 Then Ang = Ang + 3.141592 * 2
  
  ComputeFPS
  
  
Loop
TreatError3:
Debug.Print "Erreur dans Game :"; Err.Description; " "; Err.Number
Debug.Print "Error in Sub Game"
Unload3D
End
End Sub


Sub InitDirectDraw()
  'Create DirectDraw, set exclusive coopeerative level and set the video mode.
  Set DD = DirectX.DirectDrawCreate("")
  DD.SetCooperativeLevel Form1.hwnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
  DD.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT

  'Create primary buffer
  Dim ddsd As DDSURFACEDESC2
  ddsd.lFlags = DDSD_BACKBUFFERCOUNT Or DDSD_CAPS
  ddsd.ddsCaps.lCaps = DDSCAPS_COMPLEX Or DDSCAPS_FLIP Or DDSCAPS_3DDEVICE Or DDSCAPS_PRIMARYSURFACE
  ddsd.lBackBufferCount = 1
  Set Primary = DD.CreateSurface(ddsd)
  
  'Get the backbuffer
  Dim caps As DDSCAPS2
  caps.lCaps = DDSCAPS_BACKBUFFER Or DDSCAPS_3DDEVICE
  Set BackBuffer = Primary.GetAttachedSurface(caps)

End Sub

'The Direct3D Devices Enumerations :

Sub EnumerateDevice()
  On Error GoTo TreatError
  
  Set D3D = DD.GetDirect3D  'very important ! obtains the D3D interface !!
                            'trs important ! Obtient l'interface D3D !!
  'Enumerate / Enumre
  Set EnumDevice = D3D.GetDevicesEnum
  
  'This line choose the last driver (usually the best hardware)
  'GetCount returns the number of devices, so the last device index.
  
  'Cette ligne choisit le dernire driver (gnralement le meilleur matriel)
  'GetCount renvoie le nombre de devices, donc l'index du dernier device.
  DeviceGUID = EnumDevice.GetGuid(EnumDevice.GetCount)

  'You can of course personnalize this function, you can let the user choose the best driver. But usually, the last driver works always very well.
  'Vous pouvez bien sr personnaliser cette fonction, en laissant l'utilisateur choisir le meilleur driver. Mais gnralement le dernier device marche toujours trs bien...
  Exit Sub
  
TreatError:
  Debug.Print "Enum Device Err "; Err.Number; " "; Err.Description
  Unload3D
  
  
  
End Sub


Sub AddZBuffer()
  Dim ZEnum As Direct3DEnumPixelFormats
  Dim pxf As DDPIXELFORMAT
  
  'Enumerate the different pixel formats and choose the good one (Z-Buffer caps)
  'Enumre les diffrentes sortes de formats de pixels et choisis le bon (avec le flags Z-BUFFER)
  
  Set ZEnum = D3D.GetEnumZBufferFormats(DeviceGUID)

  For i = 1 To ZEnum.GetCount
   ZEnum.GetItem i, pxf
   If (pxf.lFlags And DDPF_ZBUFFER) And (pxf.lZBufferBitDepth = 16) Then Exit For
  Next i
  
  'Create the surface with chosed pixel format.
  'Cr la surface avec le format de pixel choisi
  
  Dim ddsd2 As DDSURFACEDESC2
  ddsd2.ddpfPixelFormat = pxf
  ddsd2.lFlags = DDSD_CAPS Or DDSD_PIXELFORMAT Or DDSD_WIDTH Or DDSD_HEIGHT
  ddsd2.ddsCaps.lCaps = DDSCAPS_ZBUFFER Or DDSCAPS_VIDEOMEMORY
  ddsd2.lWidth = 640   ' !! You must adapt the size in order of the backbuffer size !
  ddsd2.lHeight = 480   ' Vous devez adapter la taille en fonction des dimensions du BackBuffer
  Set ZBuffer = DD.CreateSurface(ddsd2)
  
  'Finally attach the Z-Buffer
  'Finalement attache le Z-Buffer
  BackBuffer.AddAttachedSurface ZBuffer

End Sub

Sub Init3DDevice()
On Error GoTo TreatError2
Set Device = D3D.CreateDevice(DeviceGUID, BackBuffer)

  'Viewport
  Viewport.lHeight = 480  '
  Viewport.lWidth = 640
  Viewport.lX = 0
  Viewport.lY = 0
  Viewport.minz = 0
  Viewport.maxz = 1
  
  
  Exit Sub
TreatError2:
 Debug.Print "Erreur CreateDevice :"; Err.Description; " : N "; Err.Number
 Unload3D
 End
 
End Sub

Sub Init3DGame()
   With DirectX
     .IdentityMatrix Projection3D
     .ProjectionMatrix Projection3D, 1, 2000, 3.141592653 / 2
   End With
   Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, Projection3D
'Disable the light engine (for D3DLVERTEX and D3DTLVERTEX)
'Dsactive le moteur de lumire (pour travailler avec des D3DLVERTEX et D3DTLVERTEX)
Device.SetRenderState D3DRENDERSTATE_LIGHTING, False

'Pas ncssaire mais / Not necessary but..
Device.SetRenderState D3DRENDERSTATE_AMBIENT, DirectX.CreateColorRGBA(1, 1, 1, 1)

'Set the shade mode (phong, flat, gouraud)
'Configure le mode de dgrad (phong, plat, ou gouraud)
Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_FLAT
'Set the render mode (solid, points, wireframes)
'Configure le mode de rendu (soliden, point, fil de fer)
Device.SetRenderState D3DRENDERSTATE_FILLMODE, D3DFILL_SOLID

  'Set the texture filter (more beautiful...)
  'Configure les filtres de textures (plus jolis car plus lisses)
  Device.SetTextureStageState 0, D3DTSS_MINFILTER, 2
  Device.SetTextureStageState 0, D3DTSS_MAGFILTER, 2

End Sub
Sub Main()
  InitDirectDraw
  EnumerateDevice
  AddZBuffer
  Init3DDevice
  Init3DGame
  Game
End Sub


Sub Unload3D()
  
  Set Primary = Nothing
  Set BackBuffer = Nothing
  Set DD = Nothing
  Set Device = Nothing
  Set D3D = Nothing
  Set DirectX = Nothing
  
  End
  
End Sub


Function Vector(X, Y, Z) As D3DVECTOR
 Vector.X = X
 Vector.Y = Y
 Vector.Z = Z
End Function


